/********************************** (C) COPYRIGHT *******************************
* File Name          : UDisk_Func_CreatDir.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2022/11/22
* Description        : USB full-speed port host operation functions.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*******************************************************************************/
/* Header File */
#include "Udisk_Operation.h"

/*******************************************************************************
* Function Name  : CreateDirectory
* Description    : ½Ŀ¼,Ŀ¼ѾֱӴ򿪣Ŀ¼mCmdParam.Create.mPathName,ļͬ
* Input          :
* Output         : None
* Return         : ERR_SUCCESS = Ŀ¼ɹߴĿ¼ɹ,
                   ERR_FOUND_NAME = Ѿͬļ,
                   ERR_MISS_DIR = ·ЧϼĿ¼
*******************************************************************************/
uint8_t   CreateDirectory(void)
{
    uint8_t   i, j;
    uint32_t  UpDirCluster;
    uint8_t * DirXramBuf;
    uint8_t * DirConstData;
    j = 0xFF;
    for(i = 0; i != sizeof(mCmdParam.Create.mPathName); i ++)         //Ŀ¼·
    {
        if(mCmdParam.Create.mPathName[ i ] == 0)
        {
            break;
        }
        if(mCmdParam.Create.mPathName[ i ] == PATH_SEPAR_CHAR1 || mCmdParam.Create.mPathName[ i ] == PATH_SEPAR_CHAR2)
        {
            j = i;                                                     //¼ϼĿ¼
        }
    }
    i = ERR_SUCCESS;
    if(j == 0 || (j == 2 && mCmdParam.Create.mPathName[1] == ':'))
    {
        UpDirCluster = 0;                                              //ڸĿ¼´Ŀ¼
    }
    else
    {
        if(j != 0xFF)                                                  //ھ·ӦûȡϼĿ¼ʼغ
        {
            mCmdParam.Create.mPathName[ j ] = 0;
            i = CH103FileOpen();                                       //ϼĿ¼
            if(i == ERR_SUCCESS)
            {
                i = ERR_MISS_DIR;                                      //ļĿ¼
            }
            else if(i == ERR_OPEN_DIR)
            {
                i = ERR_SUCCESS;                                       //ɹϼĿ¼
            }
            mCmdParam.Create.mPathName[ j ] = PATH_SEPAR_CHAR1;        //ָĿ¼ָ
        }
        UpDirCluster = CH103vStartCluster;                             //ϼĿ¼ʼغ
    }
    if(i == ERR_SUCCESS)                                               //ɹȡϼĿ¼ʼغ
    {
        i = CH103FileOpen();                                           //򿪱Ŀ¼
        if(i == ERR_SUCCESS)
        {
            i = ERR_FOUND_NAME;                                        //ļĿ¼
        }
        else if(i == ERR_OPEN_DIR)
        {
            i = ERR_SUCCESS;                                           //Ŀ¼Ѿ
        }
        else if(i == ERR_MISS_FILE)                                    //Ŀ¼,½
        {
            i = CH103FileCreate();                                     //ԴļķĿ¼
            if(i == ERR_SUCCESS)
            {
                if(pDISK_FAT_BUF == pDISK_BASE_BUF)
                {
                    memset(pDISK_FAT_BUF, 0, CH103vStartCluster);   //FILE_DATA_BUFDISK_BASE_BUF̻
                }
                DirXramBuf = pDISK_FAT_BUF;                            //ļݻ
                DirConstData = (uint8_t *)".          \x10\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x21\x30\x0\x0\x0\x0\x0\x0..         \x10\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x21\x30\x0\x0\x0\x0\x0\x0";
                for(i = 0x40; i != 0; i --)                            //Ŀ¼ıԪ,ֱָϼĿ¼
                {
                    *DirXramBuf = *DirConstData;
                    DirXramBuf ++;
                    DirConstData ++;
                }
                *(pDISK_FAT_BUF + 0x1A) = ((uint8_t*)&CH103vStartCluster)[3];//ʼغ
                *(pDISK_FAT_BUF + 0x1B) = ((uint8_t*)&CH103vStartCluster)[2];
                *(pDISK_FAT_BUF + 0x14) = ((uint8_t*)&CH103vStartCluster)[1];
                *(pDISK_FAT_BUF + 0x15) = ((uint8_t*)&CH103vStartCluster)[0];
                *(pDISK_FAT_BUF + 0x20 + 0x1A) = ((uint8_t*)&UpDirCluster)[3]; //ϼĿ¼ʼغ
                *(pDISK_FAT_BUF + 0x20 + 0x1B) = ((uint8_t*)&UpDirCluster)[2];
                *(pDISK_FAT_BUF + 0x20 + 0x14) = ((uint8_t*)&UpDirCluster)[1];
                *(pDISK_FAT_BUF + 0x20 + 0x15) = ((uint8_t*)&UpDirCluster)[0];
//              for ( count = 0x40; count != CHRV3vSectorSizeH*256; count ++ )
//                {
//                    /* Ŀ¼ʣಿ */
//                  *DirXramBuf = 0;
//                  DirXramBuf ++;
//              }
                mCmdParam.Write.mSectorCount = 1;
                mCmdParam.Write.mDataBuffer = pDISK_FAT_BUF;                //ָļݻʼַ
                i = CH103FileWrite();                                       //ļд
                if(i == ERR_SUCCESS)
                {
                    DirXramBuf = pDISK_FAT_BUF;
                    for(i = 0x40; i != 0; i --)                             //Ŀ¼
                    {
                        *DirXramBuf = 0;
                        DirXramBuf ++;
                    }
                    for(j = 1; j != CH103vSecPerClus; j ++)
                    {
                        if(pDISK_FAT_BUF == pDISK_BASE_BUF)
                        {
                            memset(pDISK_FAT_BUF, 0, CH103vSectorSize); //FILE_DATA_BUFDISK_BASE_BUF̻
                        }
                        mCmdParam.Write.mSectorCount = 1;
                        mCmdParam.Write.mDataBuffer = pDISK_FAT_BUF;         //ָļݻʼַ
                        i = CH103FileWrite();                                //Ŀ¼ʣ
                        if(i != ERR_SUCCESS)
                        {
                            break;
                        }
                    }
                    if(j == CH103vSecPerClus)                                 //ɹĿ¼
                    {
                        mCmdParam.Modify.mFileSize = 0;                       //Ŀ¼ĳ0
                        mCmdParam.Modify.mFileDate = 0xFFFF;
                        mCmdParam.Modify.mFileTime = 0xFFFF;
                        mCmdParam.Modify.mFileAttr = 0x10;                    //Ŀ¼
                        i = CH103FileModify();                                //ļϢ޸ΪĿ¼
                    }
                }
            }
        }
    }
    return(i);
}

/*********************************************************************
 * @fn      UDisk_USBH_CreatDirectory
 *
 * @brief   Demo Function For UDisk Create Directory (EXAM9)
 *
 * @return  none
 */
void UDisk_USBH_CreatDirectory( void )
{
    uint8_t  i;
    uint8_t  ret;

    UDisk_USBH_DiskReady( );
    if( ( CH103DiskStatus >= DISK_MOUNTED )&&( UDisk_Opeation_Flag == 1 ) )
    {
        UDisk_Opeation_Flag = 0;
        printf("CHRV3DiskStatus:%02x\r\n",CH103DiskStatus);
        printf( "Create Level 1 Directory /YEAR2004 \r\n" );
        strcpy( (char *)mCmdParam.Create.mPathName, "/YEAR2004" );     //Ŀ¼,Ŀ¼ڸĿ¼
        ret = CreateDirectory( );                                      //½ߴĿ¼
        mStopIfError( ret );
        /* Ŀ¼½ߴ򿪳ɹ,Ŀ¼½һʾļ */
        printf( "Create New File /YEAR2004/DEMO2004.TXT \r\n" );
        strcpy( (char *)mCmdParam.Create.mPathName, "/YEAR2004/DEMO2004.TXT" );//ļ
        ret = CH103FileCreate( );                                      //½ļ,ļѾɾ½
        mStopIfError( ret );
        printf( "Write some data to file DEMO2004.TXT \r\n" );
        i = sprintf( (char *)Com_Buffer, "ʾļ\xd\xa" );
        mCmdParam.ByteWrite.mByteCount = i;                            //ָдֽ,ζдĳȲܳMAX_BYTE_IO
        mCmdParam.ByteWrite.mByteBuffer = Com_Buffer;                  //ָ򻺳
        ret = CH103ByteWrite( );                                       //ֽΪλļд,ζдĳȲܳMAX_BYTE_IO
        mStopIfError( ret );
        printf( "Close file DEMO2004.TXT \r\n" );
        mCmdParam.Close.mUpdateLen = 1;                                //Զļ,ֽΪλдļ,óرļԱԶļ
        ret = CH103FileClose( );
        mStopIfError( ret );
        /* ½Ŀ¼,ǰһĿ¼ȫͬ */
        printf( "Create Level 2 Directory /YEAR2004/MONTH05 \r\n" );
        strcpy( (char *)mCmdParam.Create.mPathName, "/YEAR2004/MONTH05" );    //Ŀ¼,Ŀ¼YEAR2004Ŀ¼,YEAR2004Ŀ¼ȴ
        ret = CreateDirectory( );                                     //½ߴĿ¼
        mStopIfError( ret );
        printf( "Close\r\n" );
        mCmdParam.Close.mUpdateLen = 0;                               //Ŀ¼ҪԶļ
        ret = CH103FileClose( );                                      //رĿ¼,Ŀ¼Ҫر,رֻΪ˷ֹ
        mStopIfError( ret );
    }
}


