/********************************** (C) COPYRIGHT *******************************
 * File Name          : CH32F103UFI.C
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2019/10/15
 * Description        : USB-flash File Interface for CH103
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
*******************************************************************************/
/* CH103 Uļϵͳӿ, ֧: FAT12/FAT16/FAT32 */

//#define DISK_BASE_BUF_LEN		512	/* ĬϵĴݻСΪ512ֽ(ѡΪ20484096֧ĳЩU),Ϊ0ֹڱļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹڱļж建,ӦóڵCH103LibInit֮ǰõĻʼַpDISK_BASE_BUF */

//#define NO_DEFAULT_ACCESS_SECTOR	    1		/* ֹĬϵĴдӳ,бдĳ */
//#define NO_DEFAULT_DISK_CONNECT		1		/* ֹĬϵļӳ,бдĳ */
//#define NO_DEFAULT_FILE_ENUMER		1		/* ֹĬϵļöٻص,бдĳ */

#include "CH32F103UFI.H" 

UINT8 USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT32 timeout )
{
    uint8_t ret;
    ret = USBFSH_Transact( endp_pid, tog, timeout );
    //printf( "00 ret %02x\r\n", ret );
    return ret;
}

UINT8 HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen )
{
    uint8_t  ret;
    uint16_t *retlen;
    retlen = (uint16_t *)RetLen;
    ret = USBFSH_CtrlTransfer( RootHubDev.bEp0MaxPks, DataBuf, retlen );
    //printf( "01 ret %02x\r\n", ret );
    return ret;
}

void CopySetupReqPkg( const UINT8 *pReqPkt )
{
    uint8_t i;

    for(i = 0; i != sizeof(USB_SETUP_REQ); i++)
    {
        ((char *)pUSBFS_SetupRequest)[i] = *pReqPkt;
        pReqPkt++;
    }
}

UINT8 CtrlGetDeviceDescr( PUINT8 DataBuf )
{
    uint8_t ret;
    ret = USBFSH_GetDeviceDescr( &RootHubDev.bEp0MaxPks, DataBuf );
    //printf( "02 ret %02x\r\n", ret );
    return ret;
}

UINT8 CtrlGetConfigDescr( PUINT8 DataBuf )
{
    uint16_t len;
    uint8_t  ret;
    ret = USBFSH_GetConfigDescr( RootHubDev.bEp0MaxPks, DataBuf, DEF_COM_BUF_LEN, &len );
    //printf( "03 ret %02x\r\n", ret );
    return ret;
}

UINT8 CtrlSetUsbConfig( UINT8 cfg )
{
    uint8_t ret;
    ret = USBFSH_SetUsbConfig( RootHubDev.bEp0MaxPks, cfg );
    //printf( "04 ret %02x\r\n", ret );
    return ret;
}

UINT8 CtrlSetUsbAddress( UINT8 addr )
{
    uint8_t ret;
    ret = USBFSH_SetUsbAddress( RootHubDev.bEp0MaxPks, addr );
    //printf( "05 ret %02x\r\n", ret );
    return ret;
}

UINT8 CtrlClearEndpStall( UINT8 endp )
{
    uint8_t ret;
//    printf( "06 endp %02x\r\n", endp );
    ret = USBFSH_ClearEndpStall( RootHubDev.bEp0MaxPks, endp );
//    printf( "06 ret %02x\r\n", ret );
    return ret;
}

#ifndef FOR_ROOT_UDISK_ONLY
UINT8 CtrlGetHubDescr( void )
{

}

UINT8 HubGetPortStatus( UINT8 HubPortIndex )
{

}

UINT8 HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{

}

UINT8 HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{

}
#endif

CMD_PARAM_I	mCmdParam;						/*  */
#if		DISK_BASE_BUF_LEN > 0
//UINT8	DISK_BASE_BUF[ DISK_BASE_BUF_LEN ] __attribute__((at(BA_RAM+SZ_RAM/2)));	/* ⲿRAMĴݻ,Ϊһĳ */
UINT8	DISK_BASE_BUF[ DISK_BASE_BUF_LEN ] __attribute__((aligned (4)));	/* ⲿRAMĴݻ,Ϊһĳ */
//UINT8	DISK_FAT_BUF[ DISK_BASE_BUF_LEN ] __attribute__((aligned (4)));	/* ⲿRAMĴFATݻ,Ϊһĳ */
#endif

/* ³ԸҪ޸ */

#ifndef	NO_DEFAULT_ACCESS_SECTOR		/* ӦóжNO_DEFAULT_ACCESS_SECTORԽֹĬϵĴдӳ,Ȼбдĳ */
//if ( use_external_interface ) {  // 滻Uײдӳ
//    CH103vSectorSize=512;  // ʵʵС,512ı,ֵǴ̵С
//    CH103vSectorSizeB=9;   // ʵʵСλ,512Ӧ9,1024Ӧ10,2048Ӧ11
//    CH103DiskStatus=DISK_MOUNTED;  // ǿƿ豸ӳɹ(ֻļϵͳ)
//}

UINT8	CH103ReadSector( UINT8 SectCount, PUINT8 DataBuf )  /* Ӵ̶ȡݵ */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extReadSector( CH103vLbaCurrent, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		pCBW -> mCBW_DataLen = (UINT32)SectCount << CH103vSectorSizeB;  /* ݴ䳤 */ 
		pCBW -> mCBW_Flag = 0x80;
		pCBW -> mCBW_LUN = CH103vCurrentLun;
		pCBW -> mCBW_CB_Len = 10;
		pCBW -> mCBW_CB_Buf[ 0 ] = SPC_CMD_READ10;
		pCBW -> mCBW_CB_Buf[ 1 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 2 ] = (UINT8)( CH103vLbaCurrent >> 24 );
		pCBW -> mCBW_CB_Buf[ 3 ] = (UINT8)( CH103vLbaCurrent >> 16 );
		pCBW -> mCBW_CB_Buf[ 4 ] = (UINT8)( CH103vLbaCurrent >> 8 );
		pCBW -> mCBW_CB_Buf[ 5 ] = (UINT8)( CH103vLbaCurrent );
		pCBW -> mCBW_CB_Buf[ 6 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 7 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 8 ] = SectCount;
		pCBW -> mCBW_CB_Buf[ 9 ] = 0x00;
		CH103BulkOnlyCmd( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CH103IntStatus == ERR_SUCCESS ) {
			return( ERR_SUCCESS );
		}
		CH103IntStatus = CH103AnalyzeError( retry );
		if ( CH103IntStatus != ERR_SUCCESS ) {
			return( CH103IntStatus );
		}
	}
	return( CH103IntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}

#ifdef	EN_DISK_WRITE
UINT8	CH103WriteSector( UINT8 SectCount, PUINT8 DataBuf )  /* еĶݿд */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extWriteSector( CH103vLbaCurrent, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		pCBW -> mCBW_DataLen = (UINT32)SectCount << CH103vSectorSizeB;  /* ݴ䳤 */
		pCBW -> mCBW_Flag = 0x00;
		pCBW -> mCBW_LUN = CH103vCurrentLun;
		pCBW -> mCBW_CB_Len = 10;
		pCBW -> mCBW_CB_Buf[ 0 ] = SPC_CMD_WRITE10;
		pCBW -> mCBW_CB_Buf[ 1 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 2 ] = (UINT8)( CH103vLbaCurrent >> 24 );
		pCBW -> mCBW_CB_Buf[ 3 ] = (UINT8)( CH103vLbaCurrent >> 16 );
		pCBW -> mCBW_CB_Buf[ 4 ] = (UINT8)( CH103vLbaCurrent >> 8 );
		pCBW -> mCBW_CB_Buf[ 5 ] = (UINT8)( CH103vLbaCurrent );
		pCBW -> mCBW_CB_Buf[ 6 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 7 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 8 ] = SectCount;
		pCBW -> mCBW_CB_Buf[ 9 ] = 0x00;
		CH103BulkOnlyCmd( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CH103IntStatus == ERR_SUCCESS ) {
			Delay_Us( 200 );  /* дʱ */ 
			return( ERR_SUCCESS );
		}
		CH103IntStatus = CH103AnalyzeError( retry );
		if ( CH103IntStatus != ERR_SUCCESS ) {
			return( CH103IntStatus );
		}
	}
	return( CH103IntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}
#endif
#endif  // NO_DEFAULT_ACCESS_SECTOR

#ifndef	NO_DEFAULT_DISK_CONNECT			/* ӦóжNO_DEFAULT_DISK_CONNECTԽֹĬϵļӳ,Ȼбдĳ */
// only one host port
#define	UHUB0_CTRL		R8_UHOST_CTRL
#define	UHUB1_CTRL		R8_UHOST_CTRL
#define	bUHS_H0_ATTACH	RB_UMS_DEV_ATTACH
#define	bUHS_H1_ATTACH	RB_UMS_DEV_ATTACH
/* Ƿ */
UINT8	CH103DiskConnect( void )
{
	R8_USB_DEV_AD &= 0x7F;
	if ( R8_USB_DEV_AD == USB_DEVICE_ADDR || R8_USB_DEV_AD == USB_DEVICE_ADDR + 1 ) {  /* Root-HUBµUSB豸 */
		if ( ( R8_USB_DEV_AD == USB_DEVICE_ADDR ? UHUB0_CTRL : UHUB1_CTRL ) & RB_UH_PORT_EN ) {  /* Root-HUBµUSB豸δ */
			return( ERR_SUCCESS );  /* USB豸Ѿδ */
		}
		else if ( R8_USB_MIS_ST & (UINT8)( R8_USB_DEV_AD == USB_DEVICE_ADDR ? bUHS_H0_ATTACH : bUHS_H1_ATTACH ) ) {  /* Root-HUBµUSB豸 */
//mDiskConnect:
			CH103DiskStatus = DISK_CONNECT;  /* Ͽ */
			return( ERR_SUCCESS );  /* ⲿHUBUSB豸Ѿӻ߶Ͽ */
		}
		else {  /* USB豸Ͽ */
mDiskDisconn:
			CH103DiskStatus = DISK_DISCONNECT;
			return( ERR_USB_DISCON );
		}
	}
#ifndef	FOR_ROOT_UDISK_ONLY
	else if ( (R8_USB_DEV_AD > 0x10 && R8_USB_DEV_AD <= 0x14) || (R8_USB_DEV_AD > 0x20 && R8_USB_DEV_AD <= 0x24) ) {  /* ⲿHUBĶ˿µUSB豸 */
		if ( ( R8_USB_DEV_AD & 0x20 ? UHUB1_CTRL : UHUB0_CTRL ) & RB_UH_PORT_EN ) {  /* Root-HUBµⲿHUBδ */
			TxBuffer[ MAX_PACKET_SIZE - 1 ] = R8_USB_DEV_AD;  /*  */
			R8_USB_DEV_AD = USB_DEVICE_ADDR - 1 + ( R8_USB_DEV_AD >> 4 );  /* USB˵USBַָHUB */
			CH103IntStatus = HubGetPortStatus( TxBuffer[ MAX_PACKET_SIZE - 1 ] & 0x0F );  /* ѯHUB˿״̬,TxBuffer */
			if ( CH103IntStatus == ERR_SUCCESS ) {
				if ( TxBuffer[2] & (1<<(HUB_C_PORT_CONNECTION-0x10)) ) {  /* ⵽HUB˿ϵĲ¼ */
					CH103DiskStatus = DISK_DISCONNECT;  /* ٶΪHUB˿ϵUSB豸Ͽ */
					HubClearPortFeature( TxBuffer[ MAX_PACKET_SIZE - 1 ] & 0x0F, HUB_C_PORT_CONNECTION );  /* HUB˿¼״̬ */
				}
				R8_USB_DEV_AD = TxBuffer[ MAX_PACKET_SIZE - 1 ];  /* USB˵USBַָUSB豸 */
				if ( TxBuffer[0] & (1<<HUB_PORT_CONNECTION) ) {  /* ״̬ */
					if ( CH103DiskStatus < DISK_CONNECT ) {
						CH103DiskStatus = DISK_CONNECT;  /* Ͽ */
					}
					return( ERR_SUCCESS );  /* USB豸Ѿӻ߶Ͽ */
				}
				else {
					CH103DiskStatus = DISK_CONNECT;
					return( ERR_HUB_PORT_FREE );  /* HUBѾӵHUB˿δӴ */
				}
			}
			else {
				R8_USB_DEV_AD = TxBuffer[ MAX_PACKET_SIZE - 1 ];  /* USB˵USBַָUSB豸 */
				if ( CH103IntStatus == ERR_USB_DISCON ) {
					goto mDiskDisconn;
				}
				else {
					CH103DiskStatus = DISK_CONNECT;  /* HUBʧ */
					return( CH103IntStatus );
				}
			}
		}
		else if ( R8_USB_MIS_ST & (UINT8)( R8_USB_DEV_AD & 0x20 ? bUHS_H1_ATTACH : bUHS_H0_ATTACH ) ) {  /* Root-HUBµUSB豸,ⲿHUBUSB豸Ѿӻ߶Ͽ */
			goto mDiskConnect;
		}
		else {  /* ⲿHUBϿ */
			CH103DiskStatus = DISK_DISCONNECT;
			goto mDiskDisconn;
		}
	}
#endif
	else {
		goto mDiskDisconn;
	}
}
#endif  // NO_DEFAULT_DISK_CONNECT

#ifndef	NO_DEFAULT_FILE_ENUMER			/* ӦóжNO_DEFAULT_FILE_ENUMERԽֹĬϵļöٻص,Ȼбдĳ */
void xFileNameEnumer( void )			/* ļöٻصӳ */
{
/* ָöCH103vFileSizeΪ0xFFFFFFFFFileOpenôÿһļFileOpenñص
   صxFileNameEnumerغFileOpenݼCH103vFileSizeöֱļĿ¼ǣ
   ڵFileOpen֮ǰһȫֱΪ0FileOpenص󣬱CH103vFdtOffsetõṹFAT_DIR_INFO
   ṹеDIR_AttrԼDIR_NameжǷΪļĿ¼¼Ϣȫֱ
   FileOpenغжϷֵERR_MISS_FILEERR_FOUND_NAMEΪɹȫֱΪЧļ
   ڱصxFileNameEnumerнCH103vFileSizeΪ1ô֪ͨFileOpenǰǻص */
#if		0
	UINT8			i;
	UINT16			FileCount;
	PX_FAT_DIR_INFO	pFileDir;
	PUINT8			NameBuf;
	pFileDir = (PX_FAT_DIR_INFO)( pDISK_BASE_BUF + CH103vFdtOffset );  /* ǰFDTʼַ */
	FileCount = (UINT16)( 0xFFFFFFFF - CH103vFileSize );  /* ǰļö,CH103vFileSizeֵ0xFFFFFFFF,ҵļݼ */
	if ( FileCount < sizeof( FILE_DATA_BUF ) / 12 ) {  /* 黺Ƿ㹻,ٶÿļռ12ֽڴ */
		NameBuf = & FILE_DATA_BUF[ FileCount * 12 ];  /* 㱣浱ǰļĻַ */
		for ( i = 0; i < 11; i ++ ) NameBuf[ i ] = pFileDir -> DIR_Name[ i ];  /* ļ,Ϊ11ַ,δո */
//		if ( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) NameBuf[ i ] = 1;  /* жĿ¼ */
		NameBuf[ i ] = 0;  /* ļ */
	}
#endif
}
#endif  // NO_DEFAULT_FILE_ENUMER

UINT8	CH103LibInit( void )  /* ʼCH103,ɹ0 */
{
	if ( CH103GetVer( ) < CH103_LIB_VER ) return( 0xFF );  /* ȡǰӳİ汾,汾̫򷵻ش */
#if		DISK_BASE_BUF_LEN > 0
	pDISK_BASE_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴݻ */
	pDISK_FAT_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFԽԼRAM */
//	pDISK_FAT_BUF = & DISK_FAT_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFٶ */
/* ϣļȡٶ,ôеCH103LibInit֮,pDISK_FAT_BUFָһpDISK_BASE_BUFͬСĻ */
#endif
	CH103DiskStatus = DISK_UNKNOWN;  /* δ֪״̬ */
	CH103vSectorSizeB = 9;  /* Ĭϵ̵512B */
	CH103vSectorSize = 512;  // Ĭϵ̵512B,ֵǴ̵С
	CH103vStartLba = 0;  /* ĬΪԶFDDHDD */
    CH103vPacketSize = 64;  /* USB洢豸:64@FS,512@HS/SS,Ӧóʼ,öU̺Ǹٻ߳ôʱΪ512 */
    pTX_DMA_A_REG = (PUINT32)&R16_UH_TX_DMA;  /* ָDMAַĴ,Ӧóʼ */
	pRX_DMA_A_REG = (PUINT32)&R16_UH_RX_DMA;  /* ָDMAַĴ,Ӧóʼ */
	pTX_LEN_REG = (PUINT16)&R8_UH_TX_LEN;  /* ָͳȼĴ,Ӧóʼ */
	pRX_LEN_REG = (PUINT16)&R8_USB_RX_LEN;  /* ָճȼĴ,Ӧóʼ */
    
	return( ERR_SUCCESS );
}
